diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index d7e4749..e01a9ec 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -3594,7 +2715,7 @@ _cl5PurgeRID(Object *file_obj, ReplicaId cleaned_rid)
 #define CL5_TRIM_MAX_PER_TRANSACTION 10
 
 static void
-_cl5TrimFile(Object *obj, long *numToTrim)
+_cl5TrimReplica(Replica *r)
 {
     DB_TXN *txnid;
     RUV *ruv = NULL;
@@ -3606,11 +2727,16 @@ _cl5TrimFile(Object *obj, long *numToTrim)
     PRBool abort;
     char strCSN[CSN_STRSIZE];
     int rc;
+    long numToTrim;
+
+    cldb_Handle *cldb = replica_get_file_info(r);
 
-    PR_ASSERT(obj);
+    if (!_cl5CanTrim ((time_t)0, &numToTrim, r, &cldb->clConf) ) {
+        return;
+    }
 
     /* construct the ruv up to which we can purge */
-    rc = _cl5GetRUV2Purge2(obj, &ruv);
+    rc = _cl5GetRUV2Purge2(r, &ruv);
     if (rc != CL5_SUCCESS || ruv == NULL) {
         return;
     }
@@ -3627,20 +2753,20 @@ _cl5TrimFile(Object *obj, long *numToTrim)
         rc = TXN_BEGIN(s_cl5Desc.dbEnv, NULL, &txnid, 0);
         if (rc != 0) {
             slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5TrimFile - Failed to begin transaction; db error - %d %s\n",
+                          "_cl5TrimReplica - Failed to begin transaction; db error - %d %s\n",
                           rc, db_strerror(rc));
             finished = PR_TRUE;
             break;
         }
 
-        finished = _cl5GetFirstEntry(obj, &entry, &it, txnid);
+        finished = _cl5GetFirstEntry(cldb, &entry, &it, txnid);
         while (!finished && !slapi_is_shutting_down()) {
             /*
              * This change can be trimmed if it exceeds purge
              * parameters and has been seen by all consumers.
              */
             if (op.csn == NULL) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, "_cl5TrimFile - "
+                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, "_cl5TrimReplica - "
                                                                   "Operation missing csn, moving on to next entry.\n");
                 cl5_operation_parameters_done(&op);
                 finished = _cl5GetNextEntry(&entry, it);
@@ -3648,15 +2774,15 @@ _cl5TrimFile(Object *obj, long *numToTrim)
             }
             csn_rid = csn_get_replicaid(op.csn);
 
-            if ((*numToTrim > 0 || _cl5CanTrim(entry.time, numToTrim)) &&
+            if ((numToTrim > 0 || _cl5CanTrim(entry.time, &numToTrim, r, &cldb->clConf)) &&
                 ruv_covers_csn_strict(ruv, op.csn)) {
                 rc = _cl5CurrentDeleteEntry(it);
                 if (rc == CL5_SUCCESS) {
-                    rc = _cl5UpdateRUV(obj, op.csn, PR_FALSE, PR_TRUE);
+                    rc = _cl5UpdateRUV(cldb, op.csn, PR_FALSE, PR_TRUE);
                 }
                 if (rc == CL5_SUCCESS) {
-                    if (*numToTrim > 0)
-                        (*numToTrim)--;
+                    if (numToTrim > 0)
+                        (numToTrim)--;
                     count++;
                 } else {
                     /* The above two functions have logged the error */
@@ -3679,7 +2805,7 @@ _cl5TrimFile(Object *obj, long *numToTrim)
                 } else {
                     if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
                         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                                      "_cl5TrimFile - Changelog purge skipped anchor csn %s\n",
+                                      "_cl5TrimReplica - Changelog purge skipped anchor csn %s\n",
                                       csn_as_string(maxcsn, PR_FALSE, strCSN));
                     }
 
@@ -3712,7 +2838,7 @@ _cl5TrimFile(Object *obj, long *numToTrim)
             rc = TXN_ABORT(txnid);
             if (rc != 0) {
                 slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5TrimFile - Failed to abort transaction; db error - %d %s\n",
+                              "_cl5TrimReplica - Failed to abort transaction; db error - %d %s\n",
                               rc, db_strerror(rc));
             }
         } else {
@@ -3720,7 +2846,7 @@ _cl5TrimFile(Object *obj, long *numToTrim)
             if (rc != 0) {
                 finished = 1;
                 slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5TrimFile - Failed to commit transaction; db error - %d %s\n",
+                              "_cl5TrimReplica - Failed to commit transaction; db error - %d %s\n",
                               rc, db_strerror(rc));
             } else {
                 totalTrimmed += count;
@@ -3733,52 +2859,46 @@ _cl5TrimFile(Object *obj, long *numToTrim)
         ruv_destroy(&ruv);
 
     if (totalTrimmed) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5TrimFile - Trimmed %d changes from the changelog\n",
+        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5TrimReplica - Trimmed %d changes from the changelog\n",
                       totalTrimmed);
     }
 }
 
 static PRBool
-_cl5CanTrim(time_t time, long *numToTrim)
+_cl5CanTrim(time_t time, long *numToTrim, Replica *replica, CL5Config *dbTrim)
 {
     *numToTrim = 0;
 
-    if (s_cl5Desc.dbTrim.maxAge == 0 && s_cl5Desc.dbTrim.maxEntries == 0) {
+    if (dbTrim->maxAge == 0 && dbTrim->maxEntries == 0) {
         return PR_FALSE;
     }
-    if (s_cl5Desc.dbTrim.maxAge == 0) {
-        *numToTrim = cl5GetOperationCount(NULL) - s_cl5Desc.dbTrim.maxEntries;
+    if (dbTrim->maxAge == 0) {
+        *numToTrim = cl5GetOperationCount(replica) - dbTrim->maxEntries;
         return (*numToTrim > 0);
     }
 
-    if (s_cl5Desc.dbTrim.maxEntries > 0 &&
-        (*numToTrim = cl5GetOperationCount(NULL) - s_cl5Desc.dbTrim.maxEntries) > 0) {
+    if (dbTrim->maxEntries > 0 &&
+        (*numToTrim = cl5GetOperationCount(replica) - dbTrim->maxEntries) > 0) {
         return PR_TRUE;
     }
 
     if (time) {
-        return (slapi_current_utc_time() - time > s_cl5Desc.dbTrim.maxAge);
+        return (slapi_current_utc_time() - time > dbTrim->maxAge);
     } else {
         return PR_TRUE;
     }
 }
 
 static int
-_cl5ReadRUV(const char *replGen, Object *obj, PRBool purge)
+_cl5ReadRUV (cldb_Handle *cldb, PRBool purge)
 {
     int rc;
     char csnStr[CSN_STRSIZE];
     DBT key = {0}, data = {0};
     struct berval **vals = NULL;
-    CL5DBFile *file;
     char *pos;
     char *agmt_name;
 
-    PR_ASSERT(replGen && obj);
-
-    file = (CL5DBFile *)object_get_data(obj);
-    PR_ASSERT(file);
-
     agmt_name = get_thread_private_agmtname();
 
     if (purge) { /* read purge vector entry */
@@ -3789,7 +2909,7 @@ _cl5ReadRUV(const char *replGen, Object *obj, PRBool purge)
     key.size = CSN_STRSIZE;
     data.flags = DB_DBT_MALLOC;
 
-    rc = file->db->get(file->db, NULL /*txn*/, &key, &data, 0);
+    rc = cldb->db->get(cldb->db, NULL /*txn*/, &key, &data, 0);
     switch (rc) {
     case 0:
         pos = data.data;
@@ -3799,9 +2919,9 @@ _cl5ReadRUV(const char *replGen, Object *obj, PRBool purge)
             goto done;
 
         if (purge) {
-            rc = ruv_init_from_bervals(vals, &file->purgeRUV);
+            rc = ruv_init_from_bervals(vals, &cldb->purgeRUV);
         } else {
-            rc = ruv_init_from_bervals(vals, &file->maxRUV);
+            rc = ruv_init_from_bervals(vals, &cldb->maxRUV);
         }
         if (rc != RUV_SUCCESS) {
             slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
@@ -3815,13 +2935,13 @@ _cl5ReadRUV(const char *replGen, Object *obj, PRBool purge)
 
         /* delete the entry; it is re-added when file
                                is successfully closed */
-        file->db->del(file->db, NULL, &key, 0);
+        cldb->db->del(cldb->db, NULL, &key, 0);
 
         rc = CL5_SUCCESS;
         goto done;
 
     case DB_NOTFOUND: /* RUV is lost - need to construct */
-        rc = _cl5ConstructRUV(replGen, obj, purge);
+        rc = _cl5ConstructRUV(cldb, purge);
         goto done;
 
     default:
@@ -3839,7 +2959,7 @@ done:
 }
 
 static int
-_cl5WriteRUV(CL5DBFile *file, PRBool purge)
+_cl5WriteRUV (cldb_Handle *cldb, PRBool purge)
 {
     int rc;
     DBT key = {0}, data = {0};
@@ -3848,7 +2968,7 @@ _cl5WriteRUV(CL5DBFile *file, PRBool purge)
     DB_TXN *txnid = NULL;
     char *buff;
 
-    if ((purge && file->purgeRUV == NULL) || (!purge && file->maxRUV == NULL))
+    if ((purge && cldb->purgeRUV == NULL) || (!purge && cldb->maxRUV == NULL))
         return CL5_SUCCESS;
 
     if (purge) {
@@ -3858,18 +2978,18 @@ _cl5WriteRUV(CL5DBFile *file, PRBool purge)
          * matter, but it needs to be set to something so that it can be
          * flushed to changelog at shutdown and parsed at startup with the
          * regular string-to-RUV parsing routines. */
-        ruv_insert_dummy_min_csn(file->purgeRUV);
+        ruv_insert_dummy_min_csn(cldb->purgeRUV);
         key.data = _cl5GetHelperEntryKey(PURGE_RUV_TIME, csnStr);
-        rc = ruv_to_bervals(file->purgeRUV, &vals);
+        rc = ruv_to_bervals(cldb->purgeRUV, &vals);
     } else {
         key.data = _cl5GetHelperEntryKey(MAX_RUV_TIME, csnStr);
-        rc = ruv_to_bervals(file->maxRUV, &vals);
+        rc = ruv_to_bervals(cldb->maxRUV, &vals);
     }
 
-    if (!purge && _cl5CheckMaxRUV(file, file->maxRUV)) {
+    if (!purge && _cl5CheckMaxRUV(cldb, cldb->maxRUV)) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "_cl5WriteRUV - changelog maxRUV not found in changelog for file %s\n",
-                      file->name);
+                      cldb->ident);
         ber_bvecfree(vals);
         return CL5_DB_ERROR;
     }
@@ -3883,7 +3003,7 @@ _cl5WriteRUV(CL5DBFile *file, PRBool purge)
         return rc;
     }
 
-    rc = file->db->put(file->db, txnid, &key, &data, 0);
+    rc = cldb->db->put(cldb->db, txnid, &key, &data, 0);
 
     slapi_ch_free(&(data.data));
     if (rc == 0) {
@@ -3891,12 +3011,8 @@ _cl5WriteRUV(CL5DBFile *file, PRBool purge)
     } else {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "_cl5WriteRUV - Failed to write %s RUV for file %s; db error - %d (%s)\n",
-                      purge ? "purge" : "upper bound", file->name, rc, db_strerror(rc));
+                      purge ? "purge" : "upper bound", cldb->ident, rc, db_strerror(rc));
 
-        if (CL5_OS_ERR_IS_DISKFULL(rc)) {
-            cl5_set_diskfull();
-            return CL5_DB_ERROR;
-        }
         return CL5_DB_ERROR;
     }
 }
@@ -3904,29 +3020,23 @@ _cl5WriteRUV(CL5DBFile *file, PRBool purge)
 /* This is a very slow process since we have to read every changelog entry.
    Hopefully, this function is not called too often */
 static int
-_cl5ConstructRUV(const char *replGen, Object *obj, PRBool purge)
+_cl5ConstructRUV (cldb_Handle *cldb, PRBool purge)
 {
     int rc;
     CL5Entry entry;
     void *iterator = NULL;
     slapi_operation_parameters op = {0};
-    CL5DBFile *file;
     ReplicaId rid;
 
-    PR_ASSERT(replGen && obj);
-
-    file = (CL5DBFile *)object_get_data(obj);
-    PR_ASSERT(file);
-
     /* construct the RUV */
     if (purge)
-        rc = ruv_init_new(replGen, 0, NULL, &file->purgeRUV);
+        rc = ruv_init_new(cldb->ident, 0, NULL, &cldb->purgeRUV);
     else
-        rc = ruv_init_new(replGen, 0, NULL, &file->maxRUV);
+        rc = ruv_init_new(cldb->ident, 0, NULL, &cldb->maxRUV);
     if (rc != RUV_SUCCESS) {
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5ConstructRUV - "
                                                            "Failed to initialize %s RUV for file %s; ruv error - %d\n",
-                      purge ? "purge" : "upper bound", file->name, rc);
+                      purge ? "purge" : "upper bound", cldb->ident, rc);
         return CL5_RUV_ERROR;
     }
 
@@ -3935,7 +3045,7 @@ _cl5ConstructRUV(const char *replGen, Object *obj, PRBool purge)
                   "this may take several minutes...\n");
 
     entry.op = &op;
-    rc = _cl5GetFirstEntry(obj, &entry, &iterator, NULL);
+    rc = _cl5GetFirstEntry(cldb, &entry, &iterator, NULL);
     while (rc == CL5_SUCCESS) {
         if (op.csn) {
             rid = csn_get_replicaid(op.csn);
@@ -3956,15 +3066,15 @@ _cl5ConstructRUV(const char *replGen, Object *obj, PRBool purge)
             continue;
         }
         if (purge)
-            rc = ruv_set_csns_keep_smallest(file->purgeRUV, op.csn);
+            rc = ruv_set_csns_keep_smallest(cldb->purgeRUV, op.csn);
         else
-            rc = ruv_set_csns(file->maxRUV, op.csn, NULL);
+            rc = ruv_set_csns(cldb->maxRUV, op.csn, NULL);
 
         cl5_operation_parameters_done(&op);
         if (rc != RUV_SUCCESS) {
             slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5ConstructRUV - "
                                                                "Failed to update %s RUV for file %s; ruv error - %d\n",
-                          purge ? "purge" : "upper bound", file->name, rc);
+                          purge ? "purge" : "upper bound", cldb->ident, rc);
             rc = CL5_RUV_ERROR;
             continue;
         }
@@ -3981,9 +3091,9 @@ _cl5ConstructRUV(const char *replGen, Object *obj, PRBool purge)
         rc = CL5_SUCCESS;
     } else {
         if (purge)
-            ruv_destroy(&file->purgeRUV);
+            ruv_destroy(&cldb->purgeRUV);
         else
-            ruv_destroy(&file->maxRUV);
+            ruv_destroy(&cldb->maxRUV);
     }
 
     slapi_log_err(SLAPI_LOG_NOTICE, repl_plugin_name_cl,
@@ -3994,43 +3104,40 @@ _cl5ConstructRUV(const char *replGen, Object *obj, PRBool purge)
 }
 
 static int
-_cl5UpdateRUV(Object *obj, CSN *csn, PRBool newReplica, PRBool purge)
+_cl5UpdateRUV (cldb_Handle *cldb, CSN *csn, PRBool newReplica, PRBool purge)
 {
     ReplicaId rid;
     int rc = RUV_SUCCESS; /* initialize rc to avoid erroneous logs */
-    CL5DBFile *file;
-
-    PR_ASSERT(obj && csn);
 
-    file = (CL5DBFile *)object_get_data(obj);
+    PR_ASSERT(csn);
 
     /*
-     *  if purge is TRUE, file->purgeRUV must be set;
+     *  if purge is TRUE, cldb->purgeRUV must be set;
      *  if purge is FALSE, maxRUV must be set
      */
-    PR_ASSERT(file && ((purge && file->purgeRUV) || (!purge && file->maxRUV)));
+    PR_ASSERT(cldb && ((purge && cldb->purgeRUV) || (!purge && cldb->maxRUV)));
     rid = csn_get_replicaid(csn);
 
     /* update vector only if this replica is not yet part of RUV */
     if (purge && newReplica) {
-        if (ruv_contains_replica(file->purgeRUV, rid)) {
+        if (ruv_contains_replica(cldb->purgeRUV, rid)) {
             return CL5_SUCCESS;
         } else {
             /* if the replica is not part of the purgeRUV yet, add it unless it's from a cleaned rid */
-            ruv_add_replica(file->purgeRUV, rid, multimaster_get_local_purl());
+            ruv_add_replica(cldb->purgeRUV, rid, multimaster_get_local_purl());
         }
     } else {
         if (purge) {
-            rc = ruv_set_csns(file->purgeRUV, csn, NULL);
+            rc = ruv_set_csns(cldb->purgeRUV, csn, NULL);
         } else {
-            rc = ruv_set_csns(file->maxRUV, csn, NULL);
+            rc = ruv_set_csns(cldb->maxRUV, csn, NULL);
         }
     }
 
     if (rc != RUV_SUCCESS) {
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5UpdatePurgeRUV - "
                                                            "Failed to update %s RUV for file %s; ruv error - %d\n",
-                      purge ? "purge" : "upper bound", file->name, rc);
+                      purge ? "purge" : "upper bound", cldb->ident, rc);
         return CL5_RUV_ERROR;
     }
 
@@ -4060,36 +3167,22 @@ _cl5EnumConsumerRUV(const ruv_enum_data *element, void *arg)
 }
 
 static int
-_cl5GetRUV2Purge2(Object *fileObj, RUV **ruv)
+_cl5GetRUV2Purge2(Replica *replica, RUV **ruv)
 {
     int rc = CL5_SUCCESS;
-    CL5DBFile *dbFile;
-    Replica *r = NULL;
     Object *agmtObj = NULL;
     Repl_Agmt *agmt;
     Object *consRUVObj, *supRUVObj;
     RUV *consRUV, *supRUV;
     CSN *csn;
 
-    PR_ASSERT(fileObj && ruv);
-
     if (!ruv) {
         rc = CL5_UNKNOWN_ERROR;
         goto done;
     }
 
-    dbFile = (CL5DBFile *)object_get_data(fileObj);
-    PR_ASSERT(dbFile);
-
-    r = replica_get_by_name(dbFile->replName);
-
-    if (!r) {
-        rc = CL5_NOTFOUND;
-        goto done;
-    }
-
-    /* We start with this replica's RUV. See note in _cl5DoTrimming */
-    supRUVObj = replica_get_ruv(r);
+    /* We start with this replica's RUV. */
+    supRUVObj = replica_get_ruv(replica);
     PR_ASSERT(supRUVObj);
 
     supRUV = (RUV *)object_get_data(supRUVObj);
@@ -4099,7 +3192,7 @@ _cl5GetRUV2Purge2(Object *fileObj, RUV **ruv)
 
     object_release(supRUVObj);
 
-    agmtObj = agmtlist_get_first_agreement_for_replica(r);
+    agmtObj = agmtlist_get_first_agreement_for_replica(replica);
     while (agmtObj) {
         agmt = (Repl_Agmt *)object_get_data(agmtObj);
         PR_ASSERT(agmt);
@@ -4124,7 +3217,7 @@ _cl5GetRUV2Purge2(Object *fileObj, RUV **ruv)
             object_release(consRUVObj);
         }
 
-        agmtObj = agmtlist_get_next_agreement_for_replica(r, agmtObj);
+        agmtObj = agmtlist_get_next_agreement_for_replica(replica, agmtObj);
     }
 
     /* check if there is any data in the constructed ruv - otherwise get rid of it */
@@ -4140,16 +3233,37 @@ done:
     return rc;
 }
 
-static int
-_cl5GetEntryCount(CL5DBFile *file)
+int
+cl5NotifyRUVChange(Replica *replica)
 {
-    int rc;
+    int rc = 0;
+    cldb_Handle *cldb = replica_get_file_info(replica);
+    Object *ruv_obj = replica_get_ruv(replica);
+
+    PR_Lock(cldb->clLock); 
+
+    slapi_ch_free_string(&cldb->ident);
+    ruv_destroy(&cldb->maxRUV);
+    ruv_destroy(&cldb->purgeRUV);
+
+    cldb->ident = ruv_get_replica_generation ((RUV*)object_get_data (ruv_obj));
+    _cl5ReadRUV(cldb, PR_TRUE);
+    _cl5ReadRUV(cldb, PR_FALSE);
+    _cl5GetEntryCount(cldb);
+
+    PR_Unlock(cldb->clLock); 
+    object_release(ruv_obj);
+    return rc;
+}
+
+static int
+_cl5GetEntryCount(cldb_Handle *cldb)
+{
+    int rc;
     char csnStr[CSN_STRSIZE];
     DBT key = {0}, data = {0};
     DB_BTREE_STAT *stats = NULL;
 
-    PR_ASSERT(file);
-
     /* read entry count. if the entry is there - the file was successfully closed
        last time it was used */
     key.data = _cl5GetHelperEntryKey(ENTRY_COUNT_TIME, csnStr);
@@ -4157,24 +3271,24 @@ _cl5GetEntryCount(CL5DBFile *file)
 
     data.flags = DB_DBT_MALLOC;
 
-    rc = file->db->get(file->db, NULL /*txn*/, &key, &data, 0);
+    rc = cldb->db->get(cldb->db, NULL /*txn*/, &key, &data, 0);
     switch (rc) {
     case 0:
-        file->entryCount = *(int *)data.data;
+        cldb->entryCount = *(int *)data.data;
         slapi_ch_free(&(data.data));
 
         /* delete the entry. the entry is re-added when file
                                is successfully closed */
-        file->db->del(file->db, NULL, &key, 0);
+        cldb->db->del(cldb->db, NULL, &key, 0);
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
                       "_cl5GetEntryCount - %d changes for replica %s\n",
-                      file->entryCount, file->replName);
+                      cldb->entryCount, cldb->ident);
         return CL5_SUCCESS;
 
     case DB_NOTFOUND:
-        file->entryCount = 0;
+        cldb->entryCount = 0;
 
-        rc = file->db->stat(file->db, NULL, (void *)&stats, 0);
+        rc = cldb->db->stat(cldb->db, NULL, (void *)&stats, 0);
         if (rc != 0) {
             slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                           "_cl5GetEntryCount - Failed to get changelog statistics; "
@@ -4183,14 +3297,10 @@ _cl5GetEntryCount(CL5DBFile *file)
             return CL5_DB_ERROR;
         }
 
-#ifdef DB30
-        file->entryCount = stats->bt_nrecs;
-#else /* DB31 */
-        file->entryCount = stats->bt_ndata;
-#endif
+        cldb->entryCount = stats->bt_ndata;
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
                       "_cl5GetEntryCount - %d changes for replica %s\n",
-                      file->entryCount, file->replName);
+                      cldb->entryCount, cldb->ident);
 
         slapi_ch_free((void **)&stats);
         return CL5_SUCCESS;
@@ -4205,7 +3315,7 @@ _cl5GetEntryCount(CL5DBFile *file)
 }
 
 static int
-_cl5WriteEntryCount(CL5DBFile *file)
+_cl5WriteEntryCount(cldb_Handle *cldb)
 {
     int rc;
     DBT key = {0}, data = {0};
@@ -4214,21 +3324,17 @@ _cl5WriteEntryCount(CL5DBFile *file)
 
     key.data = _cl5GetHelperEntryKey(ENTRY_COUNT_TIME, csnStr);
     key.size = CSN_STRSIZE;
-    data.data = (void *)&file->entryCount;
-    data.size = sizeof(file->entryCount);
+    data.data = (void *)&cldb->entryCount;
+    data.size = sizeof(cldb->entryCount);
 
-    rc = file->db->put(file->db, txnid, &key, &data, 0);
+    rc = cldb->db->put(cldb->db, txnid, &key, &data, 0);
     if (rc == 0) {
         return CL5_SUCCESS;
     } else {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "_cl5WriteEntryCount - "
                       "Failed to write count entry for file %s; db error - %d %s\n",
-                      file->name, rc, db_strerror(rc));
-        if (CL5_OS_ERR_IS_DISKFULL(rc)) {
-            cl5_set_diskfull();
-            return CL5_DB_ERROR;
-        }
+                      cldb->ident, rc, db_strerror(rc));
         return CL5_DB_ERROR;
     }
 }
@@ -4555,7 +3661,7 @@ _cl5LDIF2Operation(char *ldifEntry, slapi_operation_parameters *op, char **replG
 }
 
 static int
-_cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_operation_parameters *op, PRBool local __attribute__((unused)), void *txn)
+_cl5WriteOperationTxn(cldb_Handle *cldb, const slapi_operation_parameters *op, void *txn)
 {
     int rc;
     int cnt;
